image: node:16.8.0

before_script:
  - "which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )"
  - mkdir -p ~/.ssh
  - echo "$SSH_PRIVATE_KEY" | tr -d '\r' > ~/.ssh/id_rsa
  - chmod 700 ~/.ssh/id_rsa
  - eval "$(ssh-agent -s)"
  - ssh-add ~/.ssh/id_rsa
  - ssh-keyscan -t rsa 64.227.1.160 > ~/.ssh/known_hosts
  - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
  - chmod 644 ~/.ssh/known_hosts

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/

stages:
  - build
  - deploy

build:
  stage: build
  rules: 
    - if: '$CI_COMMIT_BRANCH == "main"' 
      when: always
    - if: '$CI_COMMIT_BRANCH != "main"' 
      when: never
    - when: on_success
  script:
    - ls -a
    - npm install
    - node -v
    - npm run build
  artifacts:
    expire_in: 20 mins
    paths:
      - ./dist
  tags:
    - server_runner_2

deploy_main:
  stage: deploy
  rules: 
    - if: '$CI_COMMIT_BRANCH == "main"' 
      when: always
    - if: '$CI_COMMIT_BRANCH != "main"' 
      when: never
    - when: on_success
  script:
    - which rsync || ( apt update -y && apt install rsync -y )
    - ls -la
    - /sbin/ip route|awk '/default/ { print $3 }'
    - ls ./dist/
    - /usr/bin/rsync -r ./dist/ $SERVER_USER@$SERVER_IP:$PATH_DOMAIN.
  tags:
    - server_runner_2